<?php
// $Id: poll.php,v 1.7 2003/10/06 12:29:30 saka_car Exp $
/**
* Content code
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.7 $
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'front_html' ) );
require_once( $mainframe->getPath( 'class' ) );

$poll = new mosPoll( $database );

$id = mosGetParam( $_REQUEST, 'id', 0 );
$task = mosGetParam( $_REQUEST, 'task', '' );

switch ($task) {

	case "vote":
		pollAddVote( $id );
		break;

	case "results":
		pollresult( $id );
		break;
}

function pollAddVote( $uid ) {
	global $database;

	$sessioncookie = mosGetParam( $_REQUEST, 'sessioncookie', '' );

	if (!$sessioncookie) {
		echo "<script>alert(\""._ALERT_ENABLED."\"); window.history.go(-1);</script>\n";
		return;
	}

	$poll = new mosPoll( $database );
	if (!$poll->load( $uid )) {
		echo "<script>alert(\""._NOT_AUTH."\"); window.history.go(-1);</script>\n";
		return;
	}

	$cookiename = "voted$poll->id";
	$voted = mosGetParam( $_COOKIE, $cookiename, '0' );

	if ($voted) {
		print "<script> alert(\""._ALREADY_VOTE."\"); window.history.go(-1);</script>\n";
		return;
	}

	$voteid = mosGetParam( $_POST, 'voteid', 0 );
	if (!$voteid) {
		print "<script>alert(\""._NO_SELECTION."\"); window.history.go(-1);</script>\n";
		return;
	}

	setcookie( "$cookiename", '1', time()+$poll->lag );

	$database->setQuery( "UPDATE #__poll_data SET hits=hits + 1"
		."\n WHERE pollid='$poll->id' AND id='$voteid'");

	$database->query();

	$database->setQuery( "UPDATE #__polls SET voters=voters + 1"
		."\n WHERE id='$poll->id'");

	$database->query();

	$now = date("Y-m-d G:i:s");
	$database->setQuery( "INSERT INTO #__poll_date SET date='$now', vote_id='$voteid',	poll_id='$poll->id'");

	$database->query();
	mosRedirect( "index.php", ""._THANKS."" );
}

function pollresult( $uid ) {
	global $database, $mosConfig_offset;

	$poll = new mosPoll( $database );
	if (!$poll->load( $uid )) {
		echo "<script>alert(\""._NOT_AUTH."\"); window.history.go(-1);</script>\n";
		return;
	}

	$database->setQuery( "SELECT *"
	."\n FROM #__poll_data"
	."\n WHERE pollid='$poll->id' AND text <> ''"
	."\n ORDER BY id");
	$results = $database->loadObjectList();

	$database->setQuery( "SELECT MIN(date) AS mindate, MAX(date) AS maxdate"
		."\n FROM #__poll_date"
		."\n WHERE poll_id='$poll->id'"
	);

	if ($dates = $database->loadObjectList()) {
		$split_mindate_time = split( " ", $dates[0]->mindate );
		$mindate = split( "-", $split_mindate_time[0] );
		$mintime = split( ":", $split_mindate_time[1] );
		$first_vote = strftime( "%d %b %Y @ %H:%M", mktime( $mintime[0], $mintime[1], $mintime[2], $mindate[1], $mindate[2], $mindate[0] ) + ($mosConfig_offset*60*60) );

		$split_maxdate_time = split( " ", $dates[0]->maxdate );
		$maxdate = split( "-", $split_maxdate_time[0] );
		$maxtime = split( ":", $split_maxdate_time[1] );
		$last_vote = strftime( "%d %b %Y @ %H:%M", mktime( $maxtime[0], $maxtime[1], $maxtime[2], $maxdate[1], $maxdate[2], $maxdate[0] ) + ($mosConfig_offset*60*60) );
	}

	$sum = 0;

	$month = mosGetParam( $_REQUEST, 'month', '' );

	$year = date("Y");

	$where1 = '';
	$where2 = '';
	if ($month) {
		$where1 = "AND MONTH(b.date) = $month and YEAR(b.date) = $year";
		$where2 = "AND MONTH(c.date) = $month and YEAR(c.date) = $year";
	}
	$database->setQuery( "SELECT a.text, count( DISTINCT b.id ) AS hits,"
		. "\n	count( DISTINCT b.id )/COUNT( DISTINCT c.id )*100.0 AS percent"
		. "\nFROM #__poll_data AS a"
		. "\nLEFT JOIN #__poll_date AS b ON b.vote_id = a.id $where1"
		. "\nLEFT JOIN #__poll_date AS c ON c.poll_id = a.pollid $where2"
		. "\nWHERE a.pollid='$poll->id' AND a.text <> ''"
		. "\nGROUP BY a.id"
		. "\nORDER BY a.id"
	);

	$votes = $database->loadObjectList();
	echo $database->getErrorMsg();

	if ($sum <> 0) {
		for ($t = 0; $t < count($count); $t++) {
			$percent = 100*$count[$t]/$sum;
			$percentInt[$t] = (int)$percent * 4 * $BarScale;
		}
	}

	poll_html::showResults( $poll, $votes, $first_vote, $last_vote, $month );
}
?>
