<?php
// $Id: frontpage.html.php,v 1.15 2003/10/06 12:29:30 saka_car Exp $
/**
* Content code
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.15 $
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* @package MOS
* @version $Revision: 1.15 $
*/

/**
* Utility class for writing the HTML for frontpage items
*/
class HTML_frontpage {
	/**
	* Show a content item
	* @param object An object with the record data
	* @param boolean If <code>false</code>, the print button links to a popup window.  If <code>true</code> then the print button invokes the browser print method.
	*/
	function show( $row, $mask=0, $gid ) {
		global $Itemid, $mosConfig_offset;
		if ( ereg("([0-9]{4})-([0-9]{2})-([0-9]{2})[ ]([0-9]{2}):([0-9]{2}):([0-9]{2})", $row->modified, $regs ) ) {
			$date = mktime( $regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1] );
			$row->modified = $date > -1 ? strftime( "%d %B %Y %H:%M", $date + ($mosConfig_offset*60*60) ) : '-';
		}
		$arrDateTime = explode(" ", $row->created);
		$arrDate = explode("-", $arrDateTime[0]);
		$arrTime = explode(":", $arrDateTime[1]);
		$row->created = strftime ("%d %B %Y %H:%M", mktime ($arrTime[0],$arrTime[1],$arrTime[2],$arrDate[1],$arrDate[2],$arrDate[0]) + ($mosConfig_offset*60*60) );
		?>
	<table cellpadding="0" cellspacing="5" border="0" width="100%" class="contentpane">
		<tr>
			<td class="componentheading" width="100%"><?php echo $row->title;?></td>
<?php	if ($mask&MASK_POPUP) { ?>
			<td><a href="#" onclick="window.print(); return false");"><img src="images/M_images/printButton.png" border='0' alt="print" /></a></td>
<?php	} ?>
		</tr>
<?php	if (!($mask&MASK_HIDECREATEDATE)) { ?>
		<tr>
			<td class="createdate" colspan="3" align="left"> (<?php echo $row->created; ?>)</td>
		</tr>
<?php	} ?>
		<tr>
			<td valign="top" colspan="3"> <?php echo $row->text; ?> </td>
		</tr>
<?php	if ($mask&MASK_READON && strlen( trim( $row->fulltext ) )) { ?>
		<tr>
			<td colspan="3" align="left">
<?php		if($row->access <= $gid ) { ?>
				<a href="index.php?option=content&amp;task=view&amp;id=<?php echo $row->id;?>&amp;Itemid=<?php echo $Itemid;?>" class="readon"><?php echo _READ_ON;?></a>
<?php		} else { ?>
				<a href="index.php?option=com_registration&amp;task=register" class="readon"><?php echo _READ_ON_REGISTER;?></a>
<?php		} ?>
			</td>
		</tr>
<?php	} ?>
	</table>
<?php
	}

	function showLinks( &$rows, $limitstart, $limit ) {
		global $Itemid;
		$n = min( count( $rows ), $limit );
		?>
<table cellpadding="0" cellspacing="5" border="0" width="100%" class="contentpane">
  <tr>
    <td> <strong><?php echo _MORE; ?></strong> </td>
  </tr>
		<?php
		for ($i=$limitstart; $i < $n; $i++) {
		?>
  <tr>
    <td> <a href="index.php?option=content&amp;task=view&amp;id=<?php echo $rows[$i]->id;?>&amp;Itemid=<?php echo $Itemid;?>">
      <span class="blogsection"><?php echo $rows[$i]->title;?></span> </a> </td>
  </tr>
		<?php
		}
		?>
</table>
	<?php
	}
}
?>
