<?php
//Latest News//
// $Id: mod_latestnews.php,v 1.5 2003/09/19 07:19:59 rcastley Exp $
/**
* Latest News Module
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.5 $
**/

/**
* Latest News Module
*
* Displays the last 5 content items published
*/

// following line is to prevent direct access to this script via the url
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// set up the query, the '#__' is converted into the table prefix
// set all content items:
// - not on the front page :: mask=0
// - pubslished :: state=1
// - checked out :: checked_out = 0
// - not in a menu :: sectionid > 0
// - between the publish_up and publish_down dates

$query = "SELECT id, title, sectionid, catid FROM #__content"
. "\nWHERE (mask='0' AND state='1' AND checked_out='0' AND sectionid > '0')"
. "\n	AND (publish_up = '0000-00-00 00:00:00' OR publish_up <= NOW())"
. "\n	AND (publish_down = '0000-00-00 00:00:00' OR publish_down >= NOW())"
. "\nORDER BY created DESC LIMIT 5";

// initialise the query in the $database connector
// this translates the '#__' prefix into the real database prefix

$database->setQuery( $query );

// retrieve the list of returned records as an array of objects

$rows = $database->loadObjectList();

// cycle through the returned rows displaying them in a table
// with links to the content item
// escaping in and out of php is now permitted
?>
<table cellpadding="1" cellspacing="1" border="0">
<?php foreach ($rows as $row) { ?>
	<tr>
		<td valign="top"><img src="images/M_images/arrow.png" alt="" /></td>
		<td><a href="index.php?option=content&amp;task=view&amp;id=<?php echo $row->id;?>"><?php echo $row->title;?></a></td>
	</tr>
<?php } ?>
</table>